#include <signal.h>
#include <stdio.h>
#include <termios.h>


#define MAX_PASS_LEN 128

char * my_getpass (const char *prompt) {
	static char buf[MAX_PASS_LEN+1];
	char *ptr;
	sigset_t sig,sigsave;
	struct termios term,termsave;
	FILE *fp;
	int c;
	if ( (fp=fopen(ctermid(NULL),"r+")) == NULL) {
		return (NULL);
	}
	setbuf(fp,NULL);

	/* clear the signal set */
	sigemptyset(&sig);
	/* add some signals to the set */
	sigaddset(&sig,SIGINT);
	sigaddset(&sig,SIGTSTP);
	/* block signals in the set */
	sigprocmask(SIG_BLOCK,&sig,&sigsave);
	
	/* save the tty state */
	tcgetattr(fileno(fp),&termsave); 
	term=termsave;

	/* turn off echoing */
	term.c_lflag &= ~(ECHO | ECHOE | ECHOK | ECHONL);
	tcsetattr (fileno(fp),TCSAFLUSH,&term);

	/* print our prompt */
	fputs (prompt,fp);

	/* read in the password */
	ptr=buf;

	while ( (c=getc(fp)) != EOF && c != '\n') {
		if (ptr <&buf[MAX_PASS_LEN]) {
			*ptr++ = c;
		}
	}
	/* null terminate */
	*ptr=0;

	/* print a newline */
	putc('\n',fp);

	/* restore the tty to its original state */

	tcsetattr(fileno(fp),TCSAFLUSH,&termsave);

	/* put back the signals */
	sigprocmask(SIG_SETMASK,&sigsave,NULL);
	fclose(fp);	
	return(buf);
}
