/*
 * Chris Michaels
 * WMU-1991
 * (Hacked by Chris Meshkin, 94.02.05)
 * Hacked again by Matt Holtz 2.8.2000
 */

#include <config.h>


#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <sys/types.h>
#include <pwd.h>
#include <grp.h>
#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif


#ifdef SHADOW_PASSWORDS
#include <shadow.h>
#endif

/* Why is SunOS so incredibly stupid? */
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif

#define STDSHELL "/bin/tcsh"
#define SUSFILE  "/usr/local/etc/mysu.allow"

char *progname;

int   set_uid_ok( char * ,int uid , int gid );
void  nomemory();
void  usage();
char * getcrypt (char *);

main( int    argc,
      char **argv  )
{
  register int   i;
  int            uid,
                 nuid = 0; 
  int            gid,
                 ngid = 0;
  char           userid[17];
  char          *shell;
  char         **args;
  struct passwd *userpwd;
  struct group  *usergrp;
  char          *incrypt;
  char          *pass;
  char          *cryptedpw;
 
  if(!(progname= (char *)strdup(*argv))) nomemory();

  uid = getuid();
  gid = getgid();


#ifdef HAVE_SYSLOG_H
  openlog (argv[0],LOG_CONS | LOG_PID, LOG_AUTH);
#endif

/* Originally, a call to cuserid() obtained the username... This is a very
 * dangerous thing to use, as it can be spoofed rather easily.  If memory
 * serves, it uses the /etc/utmp field to obtain the textual username, and
 * on Sun systems, /etc/utmp is world writeable.
 * Instead, we use getpwuid(), and extract the name from the password
 * entry.
 */
  /* cuserid(userid); */
  if(!(userpwd= getpwuid(uid))) {
    fprintf(stderr, "%s : You are not in the password database!\n", progname);
    exit(-1);
  }
  userid[16]= '\0';
  strncpy(userid, userpwd->pw_name, 16);



/* First, we make sure that this program is set-uid to root.  If it is
 * not, we won't be able to grant root anyways, and it means this is
 * an illegal (or improperly installed) copy!
 */
  if(geteuid()) {
    fprintf(stderr, "%s : Must be set-uid ROOT!\n", progname);
#ifdef HAVE_SYSLOG_H
    syslog (LOG_CRIT,"%s run non setuid by %s",argv[0],userid);
#endif
    exit(-1);
  }

/* Now, we call set_uid_ok() to scan the demi-god list and see if this
 * person is worthy of becoming root.
 */
  if(!set_uid_ok(userid,uid,gid)) {
    fprintf(stderr, "%s : I cannot allow you to do that.\n", progname);
#ifdef HAVE_SYSLOG_H
    syslog (LOG_CRIT,"user %s illegally tried to run %s",userid,progname);
#endif
    exit(-1);
  }

  pass = my_getpass("Enter your password:");
  incrypt=getcrypt(userid);
  cryptedpw=(char*)crypt (pass,incrypt);
  if (strcmp(incrypt,cryptedpw)){
    fprintf (stderr,"Incorrect Password\n");
#ifdef HAVE_SYSLOG_H
    syslog (LOG_CRIT,"user %s failed to authenticate",userid);
#endif
    exit(-1);
  }

  
/* Here we parse the command line arguments and pick out the flags we
 * care about.
 */
  argc--; argv++;
  while(argc > 0) {
    if(!strlen(*argv)) continue;
    if(**argv != '-') break;
    if(!strncasecmp(*argv, "-uid",  min(strlen(*argv), 4))) {
      if(--argc < 1) usage();
      if(!strlen(*(++argv))) usage();
      if(isdigit(**argv)) nuid= atoi(*argv);
      else {
        if(!(userpwd= getpwnam(*argv))) {
          fprintf(stderr, "%s : \"%s\" is not in the password database!\n",
                  progname, *argv);
#ifdef HAVE_SYSLOG_H
          syslog (LOG_CRIT,"%s:attempt to become \"%s\" who is not in the password database!",*argv);
#endif
          exit(-1);
        } else nuid= userpwd->pw_uid;
      }
      argc--; argv++;
    } else if(!strncasecmp(*argv, "-gid", min(strlen(*argv), 4))) {
      if(--argc < 1) usage();
      if(!strlen(*(++argv))) usage();
      if(isdigit(**argv)) ngid= atoi(*argv);
      else {
        if(!(usergrp= getgrnam(*argv))) {
#ifdef HAVE_SYSLOG_H
          syslog (LOG_CRIT,"%s:attempt to run as group \"%s\" which is not in the group database!",*argv);
#endif
          fprintf(stderr, "%s : \"%s\" is not in the group database!\n",
                  progname, *argv);
          exit(-1);
        } else ngid= usergrp->gr_gid;
      }
      argc--; argv++;
    } else if(!strncasecmp(*argv, "-help", min(strlen(*argv), 5))) {
      usage();
    } else usage();
  }

/* And here we actually try to give them the uid they wanted.  We usually
 * find this will be root, but we also can allow you to be whomever you
 * want to be...  If that works, we'll also give you the gid you asked for.
 */
  if (setgid(ngid) == -1) {
    fprintf(stderr,"%s : Group id: %d not set\n",progname,ngid);
#ifdef HAVE_SYSLOG_H
    syslog(LOG_CRIT,"%s : Group id: %d not set\n",progname,ngid);
#endif
    exit(-1);
  }
  if(setuid(nuid) == -1) {
    fprintf(stderr,"%s : User id: %d not set.\n",progname,nuid);
#ifdef HAVE_SYSLOG_H
    syslog(LOG_CRIT,"%s : User id: %d not set.\n",progname,nuid);
#endif
    exit(-1);
  }

/* Finally, we see if you have a preference for any particular shell.  If
 * so, we'll spawn that for you, otherwise you get SUSSHELL.
 */
  if(!(shell = getenv("SHELL"))) shell= STDSHELL;

/* Now, we will construct the exec arguments from what you supplied.
 * If you supplied none, you just get a shell.
 */
  if(!(args= (char **)calloc(argc+3, sizeof(char *)))) nomemory();
  if(argc < 1) {
    if(!(args[0]= (char *)strdup(shell))) nomemory();
  } else {
    for(i= 0; i< argc; i++)
      if(!(args[i]= (char *)strdup(argv[i]))) nomemory();
    args[argc]= NULL;
  }

/* This is for debugging purposes only.
 * I try to make sure the thing makes sense...
 */
#ifdef DEBUG
  printf("[uid: %d, gid: %d] %s", geteuid(), getegid(), args[0]);
  for(i= 0; i< argc; i++)
    printf(" %s", args[i+1]);
  printf("\n");
  exit(0);
#else

  syslog (LOG_INFO,"spawning %s for %s becoming uid %i, gid %i",shell,userid,getuid(),getgid());
  execvp(args[0],args);
#endif

/* Somehow or other, this did not work!  *BOGGLE* */
  fprintf(stderr,"%s : Was not able to execute %s.\n",progname,args[0]);
  exit(-1);
}

int set_uid_ok( char * uname,
                int    uid,
                int    gid    )
{
  FILE *fp;
  char  funame[9];  /* scanf() might seg-fault on this */
  int   fuid;
  int   fgid;

/* At this point, the process should still be mortal.  Thus if write
 * access is obtainable, the person could have gone and edited the file
 * themselves... clearly this is bad.
 */
#ifdef WORKING_EUID
  if(access(SUSFILE, W_OK)) {
    fprintf(stderr,
            "%s : user database is writeable, security may be breached.\n",
            progname);
    exit(-1);
  }
#endif

/* Now, if the list of people who have access to root through this utility
 * is not desired to be world-readable, a seteuid(0) should be made before
 * this file is opened.
 */
  if(!(fp= fopen(SUSFILE, "r"))) {
    fprintf(stderr,"%s : unable to open %s\n", progname, SUSFILE);
    exit(-1);
  }

/* Finally, we scan the file to see if our combination of username,
 * userid, and groupid are present.  If they are, the user is a demi-god
 * and can be given root privs.
 * Actually, the gid and username are not needed, as the uid-alone provides
 * a unique identifier.  I wonder if this will break with the newgrp command?
 */
  while(fscanf(fp,"%d %d %s",&fuid,&fgid,funame) == 3) {
    if(  (fuid == uid)
       &&(fgid == gid)
       &&(!strncmp(funame, uname, strlen(uname)))) {
      fclose(fp);
      return 1;
    }
  }
  fclose(fp);
  return 0;  
}

void nomemory()
{
  fprintf(stderr, "Not enough memory?\n");
  exit(-1);
}

void usage()
{
  printf("usage:  %s [-uid {uid | user}] [-gid {gid | group}] [args]\n",
         progname);
  exit(1);
}


/* this part by matt holtz */
char * getcrypt (char * username) 
{
#ifdef SHADOW_PASSWORDS
	struct spwd * sp;
	sp = getspnam (username);
	return (sp->sp_pwdp);
#else
	struct passwd *pw;
	pw = getpwnam(username);
	return (pw->pw_passwd);
#endif
	
}


